#############################################################
#
# pxarc drivers and utilities
#
#############################################################

PXARC_VER:=1.1
PXARC_SOURCE:=pxarc-$(PXARC_VER).tar.gz
PXARC_SITE:=http://www.pabr.org/pxarc/dist
PXARC_DIR:=$(BUILD_DIR)/pxarc-$(PXARC_VER)
PXARC_CAT:=zcat

PXARC_MODULES=	pxa_rtsched.ko			\
		pxa_opwm.ko pxa_ipwm.ko		\
		pxa_cfcam.ko pxa_cfcam_pnm.ko
PXARC_BINARIES=	iprc_rx ppmrelay

PXARC_BUILD_MODULES=$(PXARC_MODULES:%=$(PXARC_DIR)/src/%)
PXARC_BUILD_BINARIES=$(PXARC_BINARIES:%=$(PXARC_DIR)/src/%.target)

PXARC_MODULES_DIR=$(TARGET_DIR)/lib/modules/$(LINUX_VERSION)/misc
PXARC_BINARIES_DIR=$(TARGET_DIR)/usr/bin

PXARC_INSTALL_MODULES=$(PXARC_MODULES:%=$(PXARC_MODULES_DIR)/%)
PXARC_INSTALL_BINARIES=$(PXARC_BINARIES:%=$(PXARC_BINARIES_DIR)/%)

$(DL_DIR)/$(PXARC_SOURCE):
	 $(WGET) -P $(DL_DIR) $(PXARC_SITE)/$(PXARC_SOURCE)

$(PXARC_DIR)/.unpacked: $(DL_DIR)/$(PXARC_SOURCE)
	$(PXARC_CAT) $(DL_DIR)/$(PXARC_SOURCE)	\
	| tar -C $(BUILD_DIR) $(TAR_OPTIONS) -
	touch $@

export BUILD_DIR LINUX_DIR ARCH KERNEL_CROSS TARGET_CC LINUX_VERSION

$(PXARC_BUILD_MODULES) $(PXARC_BUILD_BINARIES):	\
			$(TARGET_DIR)/boot/uImage $(PXARC_DIR)/.unpacked
	$(MAKE) -j1 -C $(PXARC_DIR)/src

$(PXARC_MODULES_DIR)/%:	$(PXARC_DIR)/src/%
	mkdir -p $(PXARC_MODULES_DIR)
	cp $^ $@
	grep -q pxaRC $(TARGET_DIR)/etc/modules  ||  (			\
	  echo >> $(TARGET_DIR)/etc/modules;				\
	  echo "# pxaRC: Customize and uncomment to load at boot time";	\
				>> $(TARGET_DIR)/etc/modules;		\
	  echo "#  NOTE: SMC91 AND PCMCIA MUST BE DISABLED."		\
				>> $(TARGET_DIR)/etc/modules;		\
	  for i in $(PXARC_MODULES:%.ko=%); do				\
	    echo "#$$i" >> $(TARGET_DIR)/etc/modules;			\
	  done)

$(PXARC_BINARIES_DIR)/%:	$(PXARC_DIR)/src/%.target
	mkdir -p $(PXARC_BINARIES_DIR)
	cp $< $@

# Need to make recursively in order to set $(LINUX_VERSION)
pxarc:	$(PXARC_DIR)/.unpacked
	$(MAKE) -j1 $(PXARC_INSTALL_MODULES) $(PXARC_INSTALL_BINARIES)

pxarc-clean:
	rm -f $(PXARC_INSTALL_MODULES) $(PXARC_INSTALL_BINARIES)
	-$(MAKE) -C $(PXARC_DIR)/src clean

pxarc-dirclean:
	rm -rf $(PXARC_DIR)

#############################################################
#
# Toplevel Makefile options
#
#############################################################
ifeq ($(strip $(BR2_PACKAGE_PXARC)),y)
TARGETS+=pxarc
endif
