#ifndef _PXA_CFCAM_H
#define _PXA_CFCAM_H

struct pxa_cfcam_transform {
  int max_frame_size;
  int history;
  void *priv_data;
  int (*transform)(struct pxa_cfcam_transform *tfm,
		   int frame, int line, char **lines, char *dst);
  void (*release)(struct pxa_cfcam_transform *tfm);
};

/* Callback function which creates a transform for a combination
   of input width, height, bits per pixel, bytes per sample. */
typedef struct pxa_cfcam_transform *
(*pxa_cfcam_createfn)(int w, int h, int bits, int bpp);

// TOOD: Allow different transforms for multiple devices.
extern int pxa_cfcam_set_transform(pxa_cfcam_createfn fn);
extern void pxa_cfcam_unset_transform();

#endif /* _PXA_CFCAM_H */
